diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40f..540ab23d 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,81 +1,284 @@
+require "json"
+require "fileutils"
 require "hive/config"
 require "hive/web/session_secret"
+require "hive/web/app_provisioner"
+require "hive/web/auth_mode"
+require "hive/invoked_binary"
 
 module Hive
   module Commands
     # Boots the hivebox web UI — a Rails app living in web/ at the repo root
-    # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # (shipped in the gem and Docker image). Local installs provision a
+    # writable runtime copy under XDG data home via AppProvisioner.
+    #
+    # Subcommands (U5): install | start | stop | status manage a systemd-user
+    # / launchd unit. Bare `hive web` (no subcommand) stays foreground.
     class Web
-      def initialize(bind: nil, port: nil)
+      VALID_SUBCOMMANDS = %w[install start stop status].freeze
+
+      def initialize(subcommand = nil, bind: nil, port: nil, json: false,
+                     force: false, unsafe_no_auth: false)
+        @subcommand = subcommand
         @bind = bind
         @port = port
+        @json = json
+        @force = force
+        @unsafe_no_auth = unsafe_no_auth
       end
 
       def call
+        case @subcommand
+        when nil then run_foreground
+        when "install" then install_service
+        when "start" then start_service
+        when "stop" then stop_service
+        when "status" then status_service
+        else
+          raise Hive::InvalidTaskPath,
+                "hive web: unknown subcommand #{@subcommand.inspect} " \
+                "(expected: #{VALID_SUBCOMMANDS.join(', ')} or bare `hive web`)"
+        end
+      end
+
+      # Resolution order (KTD-1):
+      #   1. HIVEBOX_WEB_APP_DIR (Docker / explicit override)
+      #   2. source-checkout sibling (dev)
+      #   3. provisioned XDG runtime for the *current* Hive::VERSION
+      # A provisioned dir for a different version is never used silently.
+      def rails_app_dir
+        env_dir = ENV["HIVEBOX_WEB_APP_DIR"]
+        if env_dir && File.file?(File.join(env_dir, "config", "application.rb"))
+          return env_dir
+        end
+
+        source = File.expand_path("../../../web", __dir__)
+        if File.file?(File.join(source, "config", "application.rb"))
+          return source
+        end
+
+        provisioned = Hive::Web::AppProvisioner.provisioned_app_dir
+        return provisioned if Hive::Web::AppProvisioner.provisioned?
+
+        if stale_provisioned_version
+          warn "hive web: provisioned web app is for hive #{stale_provisioned_version}, " \
+               "but this CLI is #{Hive::VERSION}. Re-run `hive setup` (or `hive web install`) " \
+               "to re-provision."
+        end
+
+        nil
+      end
+
+      private
+
+      def run_foreground
+        if @json
+          message = "hive web has no JSON output (it runs a long-lived server). " \
+                    "Use 'hive status --json' for machine-readable task data, " \
+                    "or 'hive web status --json' for the managed service."
+          puts JSON.generate(
+            "ok" => false,
+            "error_class" => "InvalidTaskPath",
+            "error_kind" => "invalid_task_path",
+            "exit_code" => Hive::ExitCodes::USAGE,
+            "message" => message
+          )
+          raise Hive::InvalidTaskPath, message
+        end
+
         cfg = Hive::Config.load_global_web
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
+        auth_mode = resolve_auth_mode!(bind, cfg)
+
         app_dir = rails_app_dir
         unless app_dir
-          warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+          warn missing_app_guidance
           exit 1
         end
 
         warn_on_public_bind(bind, cfg)
 
-        env = {
-          "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
-          # Rails' secret_key_base derives from the same persisted secret the
-          # session cookies used pre-Rails, so recreating the container keeps
-          # sessions (the file lives on the /data mount).
-          "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
-            Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
-          "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
-          # The solid_cable/cache/queue sqlite files must survive image
-          # upgrades — keep them in state_home (on /data in the container),
-          # not in the app dir.
-          "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] ||
-            File.join(Hive::Paths.state_home, "web-storage"),
-          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
-        }
+        env = boot_env(cfg, auth_mode, app_dir)
         FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
 
         Dir.chdir(app_dir) do
-          # Idempotent: creates/migrates the solid-stack sqlite databases on
-          # first boot, no-ops afterwards. Array form — no shell involved.
-          # Typed error so a persistent failure surfaces as guidance, not a
-          # raw backtrace looping every 5s under the container supervisor.
           unless system(env, "bin/rails", "db:prepare")
             raise Hive::Error,
                   "hive web: db:prepare failed — check that " \
                   "#{env.fetch("HIVEBOX_STORAGE_DIR")} is writable (the /data mount) " \
                   "and that the web bundle is installed (cd #{app_dir} && bundle install)"
           end
-          puts "hive web: listening on http://#{bind}:#{port}"
-          # Replace this process with the Rails server (array form, env hash;
-          # Kernel#exec never touches a shell when given an argv list).
+          puts "hive web: listening on http://#{bind}:#{port} (auth=#{auth_mode})"
           Kernel.exec env, "bin/rails", "server", "-b", bind, "-p", port.to_s
         end
       end
 
-      private
+      def resolve_auth_mode!(bind, cfg)
+        Hive::Web::AuthMode.assert_safe!(
+          bind: bind,
+          config: cfg,
+          unsafe_no_auth: @unsafe_no_auth
+        )
+      end
 
-      def rails_app_dir
-        candidates = [
-          ENV["HIVEBOX_WEB_APP_DIR"],
-          File.expand_path("../../../web", __dir__)
-        ].compact
-        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+      def boot_env(cfg, auth_mode, app_dir)
+        env = {
+          "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
+          "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
+            Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
+          "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
+          "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] ||
+            File.join(Hive::Paths.state_home, "web-storage"),
+          "HIVEBOX_AUTH_MODE" => auth_mode,
+          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
+        }
+        apply_provisioned_bundle_env!(env, app_dir)
+        env
+      end
+
+      def install_service
+        # Provision the app first when missing (gem install path).
+        unless rails_app_dir
+          Hive::Web::AppProvisioner.new.ensure_provisioned!
+        end
+
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new(
+          binary_path: Hive::InvokedBinary.path
+        )
+        result = installer.install!(autostart: true, force: @force)
+        installer.messages.each { |line| warn "hive: #{line}" }
+
+        if @json
+          puts JSON.generate(
+            "schema" => "hive-web-install",
+            "schema_version" => 1,
+            "ok" => %i[written upgraded unchanged unsupported autostart_unavailable].include?(result.kind),
+            "outcome" => result.kind.to_s,
+            "platform" => installer.envelope_platform,
+            "target_path" => installer.target_path,
+            "backup_path" => result.backup_path,
+            "restarted" => result.restarted,
+            "messages" => installer.messages.dup
+          )
+          raise Hive::Error, "web service install #{result.kind}" if %i[drifted failed].include?(result.kind)
+          return
+        end
+
+        case result.kind
+        when :written
+          puts "hive web: installed unit at #{installer.target_path}"
+        when :upgraded
+          puts "hive web: upgraded unit at #{installer.target_path}" \
+               "#{result.backup_path ? " (backup: #{result.backup_path})" : ""}"
+        when :unchanged
+          puts "hive web: unit already up to date at #{installer.target_path}"
+        when :drifted
+          raise Hive::Error,
+                "web unit at #{installer.target_path} differs from the current template. " \
+                "Re-run with `hive web install --force` to overwrite."
+        when :failed
+          raise Hive::Error, "web service install reported a failure; see messages above"
+        when :unsupported, :autostart_unavailable
+          puts "hive web: unit written at #{installer.target_path}; autostart not enabled on this host"
+        end
+      end
+
+      def start_service
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new
+        ok = case installer.envelope_platform
+        when "linux"
+          system("systemctl", "--user", "start", installer.service_name)
+        when "macos"
+          system("launchctl", "load", installer.target_path)
+        else
+          warn "hive web start: no service manager on this platform; run `hive web` in the foreground"
+          false
+        end
+        if @json
+          puts JSON.generate("schema" => "hive-web-status", "ok" => ok, "action" => "start")
+        else
+          puts ok ? "hive web: started" : "hive web: start failed"
+        end
+        raise Hive::Error, "web service start failed" unless ok
+      end
+
+      def stop_service
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new
+        ok = case installer.envelope_platform
+        when "linux"
+          system("systemctl", "--user", "stop", installer.service_name)
+        when "macos"
+          system("launchctl", "unload", installer.target_path)
+        else
+          warn "hive web stop: no service manager on this platform"
+          false
+        end
+        if @json
+          puts JSON.generate("schema" => "hive-web-status", "ok" => ok, "action" => "stop")
+        else
+          puts ok ? "hive web: stopped" : "hive web: stop failed"
+        end
+        raise Hive::Error, "web service stop failed" unless ok
+      end
+
+      def status_service
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new
+        state = installer.service_state
+        cfg = Hive::Config.load_global_web
+        bind = @bind || cfg.fetch("bind")
+        port = (@port || cfg.fetch("port")).to_i
+        url = "http://#{bind}:#{port}"
+        if @json
+          puts JSON.generate(
+            "schema" => "hive-web-status",
+            "schema_version" => 1,
+            "ok" => true,
+            "url" => url,
+            "service_installed" => state["service_installed"],
+            "service_enabled" => state["service_enabled"],
+            "unit_path" => state["unit_path"],
+            "platform" => state["platform"]
+          )
+        else
+          puts "hive web: url=#{url}"
+          puts "  installed: #{state['service_installed']}"
+          puts "  enabled:   #{state['service_enabled']}"
+          puts "  unit:      #{state['unit_path']}"
+        end
+      end
+
+      def missing_app_guidance
+        "hive web: the web app was not found. " \
+          "Run `hive setup` (or `hive web install`) to provision it, " \
+          "or point HIVEBOX_WEB_APP_DIR at a Rails app directory."
+      end
+
+      def stale_provisioned_version
+        root = File.join(Hive::Paths.data_home, "webapp")
+        return nil unless File.directory?(root)
+
+        Dir.children(root).find do |name|
+          name != Hive::VERSION &&
+            File.file?(File.join(root, name, "web", "config", "application.rb"))
+        end
+      end
+
+      def apply_provisioned_bundle_env!(env, app_dir)
+        marker = File.join(app_dir, Hive::Web::AppProvisioner::MARKER)
+        return unless File.file?(marker)
+
+        parent = File.dirname(app_dir)
+        bundle_path = File.join(parent, "bundle")
+        bundle_config = File.join(parent, "bundle-config")
+        env["BUNDLE_PATH"] = bundle_path if File.directory?(bundle_path)
+        env["BUNDLE_APP_CONFIG"] = bundle_config if File.directory?(bundle_config)
       end
 
-      # Rails' production host authorization is inactive by default — the box
-      # assumes a trusted reverse proxy validates Host, exactly like the
-      # pre-Rails posture. Binding a public interface without that proxy
-      # exposes the app to DNS-rebinding / Host-injection, so make it loud.
       def warn_on_public_bind(bind, cfg)
         return unless bind.to_s == "0.0.0.0"
         return if cfg["origin"].to_s.start_with?("https://")
diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 00000000..2513971b
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,61 @@
+# frozen_string_literal: true
+
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+
+module Hive
+  module Commands
+    class Web
+      # Per-user autostart installer for the web UI. Shares drift/backup/
+      # enable semantics with the daemon and bot installers.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def service_name
+          "hive-web"
+        end
+
+        def cli_label
+          "web"
+        end
+
+        def service_noun
+          "web service"
+        end
+
+        def unit_noun
+          "web unit"
+        end
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        private
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          escaped = Shellwords.escape(resolved_binary)
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          binary_dir = File.dirname(binary)
+          escaped_binary = CGI.escapeHTML(binary)
+          escaped_binary_dir = CGI.escapeHTML(binary_dir)
+          escaped_home = CGI.escapeHTML(@home)
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
+            .gsub("/Users/YOU/Library/Logs", "#{escaped_home}/Library/Logs")
+            .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index da8bd31a..5b6c4e02 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -373,6 +373,9 @@ module Hive
         "bind" => "127.0.0.1",
         "port" => 4567,
         "origin" => "http://127.0.0.1:4567",
+        # Auth mode: unset/nil = derived from bind (loopback → none,
+        # non-loopback → github). Explicit "github" or "none" wins.
+        "auth" => nil,
         "github" => {
           "owner" => nil,
           # The shared hivebox OAuth app (device flow only — public by
@@ -2277,6 +2280,13 @@ module Hive
               "web.origin in #{describe_source(source_path)} must be an http(s) URL"
       end
 
+      auth = web["auth"]
+      unless auth.nil? || %w[github none].include?(auth.to_s)
+        raise ConfigError,
+              "web.auth in #{describe_source(source_path)} must be \"github\", \"none\", or unset; " \
+              "got #{auth.inspect}"
+      end
+
       github = web["github"]
       unless github.is_a?(Hash)
         raise ConfigError,
diff --git a/lib/hive/preflight.rb b/lib/hive/preflight.rb
new file mode 100644
index 00000000..418dffb6
--- /dev/null
+++ b/lib/hive/preflight.rb
@@ -0,0 +1,412 @@
+# frozen_string_literal: true
+
+require "open3"
+require "rbconfig"
+require "timeout"
+require "hive/paths"
+require "hive/invoked_binary"
+require "hive/web/app_provisioner"
+
+module Hive
+  # Read-only dependency probes for local (non-Docker) web + daemon setup.
+  # Returns structured rows; never mutates state. Shared by `hive doctor`
+  # (`--local-web`) and `hive setup`.
+  class Preflight
+    EXIT_SUCCESS = 0
+    EXIT_MISSING = 65
+
+    Row = Struct.new(
+      :name, :status, :detail, :fix_command, :owner, :required,
+      keyword_init: true
+    ) do
+      def to_h
+        {
+          name: name,
+          status: status.to_s,
+          detail: detail,
+          fix_command: fix_command,
+          owner: owner.to_s,
+          required: required
+        }
+      end
+
+      def failing?
+        %w[missing unauthenticated drifted version_too_old error].include?(status.to_s)
+      end
+
+      def blocks_provisioning?
+        required && failing? && owner.to_s == "hive"
+      end
+    end
+
+    def initialize(project_root: nil, data_home: Hive::Paths.data_home)
+      @project_root = project_root
+      @data_home = data_home
+    end
+
+    def rows
+      @rows ||= [
+        check_ruby,
+        check_git,
+        check_tmux,
+        check_node,
+        check_npm,
+        check_sqlite,
+        check_qmd,
+        check_web_app,
+        check_gh,
+        check_agent("claude"),
+        check_agent("codex"),
+        check_daemon_service,
+        check_daemon_binary_drift,
+        check_daemon_running
+      ]
+    end
+
+    def any_required_missing?
+      rows.any? { |r| r.required && r.failing? }
+    end
+
+    def blocking_rows
+      rows.select(&:blocks_provisioning?)
+    end
+
+    def exit_code
+      any_required_missing? ? EXIT_MISSING : EXIT_SUCCESS
+    end
+
+    private
+
+    def check_ruby
+      version = RUBY_VERSION
+      major_minor = version.split(".").first(2).join(".")
+      if major_minor == "3.4" || (version.split(".").map(&:to_i) <=> [ 3, 4, 0 ]) >= 0
+        ok("ruby", "Ruby #{version}", required: true)
+      else
+        row("ruby", :missing, "Ruby #{version} (need 3.4.x for the web app)",
+            "Install Ruby 3.4 (rbenv/mise/asdf) and re-run `hive setup`",
+            owner: :external, required: true)
+      end
+    end
+
+    def check_git
+      path = which("git")
+      return missing("git", "git is not on PATH", "Install git and ensure it is on PATH",
+                     owner: :external, required: true) unless path
+
+      out, ok = capture(path, "--version")
+      return ok_row("git", out.to_s.strip, required: true) if ok
+
+      row("git", :error, "git at #{path} failed to run", "Reinstall git",
+          owner: :external, required: true)
+    end
+
+    def check_tmux
+      path = which("tmux") || ENV["HIVE_TMUX_BIN"]
+      path = path if path && File.executable?(path.to_s)
+      path ||= which("tmux")
+      return missing("tmux", "tmux is not on PATH",
+                     "Install tmux (needed for interactive claude mode)",
+                     owner: :external, required: false) unless path && File.executable?(path)
+
+      out, ok = capture(path, "-V")
+      return ok_row("tmux", out.to_s.strip, required: false) if ok
+
+      row("tmux", :error, "tmux at #{path} failed", "Reinstall tmux",
+          owner: :external, required: false)
+    end
+
+    def check_node
+      path = which("node")
+      return missing("node", "node is not on PATH",
+                     "Install Node.js/npm (needed to bootstrap qmd)",
+                     owner: :external, required: false) unless path
+
+      out, ok = capture(path, "--version")
+      return ok_row("node", out.to_s.strip, required: false) if ok
+
+      row("node", :error, "node at #{path} failed", "Reinstall Node.js",
+          owner: :external, required: false)
+    end
+
+    def check_npm
+      path = which("npm")
+      return missing("npm", "npm is not on PATH",
+                     "Install Node.js/npm (needed to bootstrap qmd)",
+                     owner: :external, required: false) unless path
+
+      out, ok = capture(path, "--version")
+      return ok_row("npm", "npm #{out.to_s.strip}", required: false) if ok
+
+      row("npm", :error, "npm at #{path} failed", "Reinstall Node.js/npm",
+          owner: :external, required: false)
+    end
+
+    def check_sqlite
+      begin
+        require "sqlite3"
+        ok("sqlite3", "sqlite3 gem loadable (#{SQLite3::VERSION})", required: true)
+      rescue LoadError => e
+        missing("sqlite3", "sqlite3 gem not loadable (#{e.message})",
+                "gem install sqlite3  # or reinstall hive-cli",
+                owner: :hive, required: true)
+      end
+    end
+
+    def check_qmd
+      path = find_qmd
+      return missing("qmd", "qmd is not installed or not discoverable",
+                     "hive setup  # or: npm install --global --prefix " \
+                     "\"${XDG_DATA_HOME:-$HOME/.local/share}/hive/qmd\" @tobilu/qmd",
+                     owner: :hive, required: false) unless path
+
+      out, ok = capture(path, "--version")
+      return ok_row("qmd", [ path, out.to_s.strip ].reject(&:empty?).join(" "), required: false) if ok
+
+      row("qmd", :error, "qmd at #{path} failed to start",
+          "npm rebuild better-sqlite3 --prefix \"#{File.dirname(File.dirname(path))}\"  # or hive setup",
+          owner: :hive, required: false)
+    end
+
+    def check_web_app
+      if Hive::Web::AppProvisioner.provisioned?(data_home: @data_home, version: Hive::VERSION)
+        dir = Hive::Web::AppProvisioner.provisioned_app_dir(data_home: @data_home, version: Hive::VERSION)
+        return ok("web_app", "provisioned at #{dir}", required: true)
+      end
+
+      # Source checkout counts as available for local-web preflight.
+      source = File.expand_path("../../web", __dir__)
+      if File.file?(File.join(source, "config", "application.rb"))
+        return ok("web_app", "source checkout at #{source}", required: true)
+      end
+
+      if ENV["HIVEBOX_WEB_APP_DIR"] &&
+         File.file?(File.join(ENV["HIVEBOX_WEB_APP_DIR"], "config", "application.rb"))
+        return ok("web_app", "HIVEBOX_WEB_APP_DIR=#{ENV['HIVEBOX_WEB_APP_DIR']}", required: true)
+      end
+
+      missing("web_app", "web app not provisioned for hive #{Hive::VERSION}",
+              "hive setup  # or: hive web install",
+              owner: :hive, required: true)
+    end
+
+    def check_gh
+      path = which("gh")
+      return missing("gh", "gh is not on PATH",
+                     "Install GitHub CLI: https://cli.github.com/  then `gh auth login`",
+                     owner: :external, required: false) unless path
+
+      _out, ok = capture(path, "auth", "status")
+      if ok
+        ok_row("gh", "#{path} authenticated", required: false)
+      else
+        row("gh", :unauthenticated, "#{path} present but not authenticated",
+            "gh auth login",
+            owner: :external, required: false)
+      end
+    end
+
+    def check_agent(name)
+      bin = agent_bin(name)
+      path = which(bin) || (File.executable?(bin) ? bin : nil)
+      fix = case name
+      when "claude" then "Install Claude Code CLI and run `claude` to log in"
+      when "codex" then "Install Codex CLI and authenticate"
+      else "Install #{name} and ensure it is on PATH"
+      end
+
+      return missing(name, "#{name} is not on PATH (looked for #{bin})", fix,
+                     owner: :external, required: false) unless path
+
+      out, ok = capture(path, "--version")
+      return ok_row(name, [ path, out.to_s.strip ].reject(&:empty?).join(" "), required: false) if ok
+
+      # Some CLIs use different version flags; presence of the binary is enough for "present".
+      ok_row(name, path, required: false)
+    end
+
+    def check_daemon_service
+      installer = daemon_installer
+      state = installer.service_state
+      if state["service_installed"]
+        detail = "unit at #{state['unit_path']}"
+        detail += state["service_enabled"] ? " (enabled)" : " (not enabled)"
+        ok("daemon_service", detail, required: true)
+      else
+        missing("daemon_service", "daemon unit not installed",
+                "hive setup  # or: hive daemon install",
+                owner: :hive, required: true)
+      end
+    rescue StandardError => e
+      row("daemon_service", :error, e.message, "hive daemon install",
+          owner: :hive, required: true)
+    end
+
+    def check_daemon_binary_drift
+      installer = daemon_installer
+      unit_path = installer.target_path
+      unless unit_path && File.exist?(unit_path)
+        return row("daemon_binary", :missing, "no daemon unit to inspect",
+                   "hive daemon install",
+                   owner: :hive, required: true)
+      end
+
+      unit_binary = installer.installed_binary_path
+      cli_binary = Hive::InvokedBinary.path
+      unless unit_binary
+        return row("daemon_binary", :error, "could not parse ExecStart from #{unit_path}",
+                   "hive daemon install --force",
+                   owner: :hive, required: true)
+      end
+
+      unless cli_binary
+        return row("daemon_binary", :error, "could not resolve current hive CLI binary",
+                   "reinstall hive or set HIVE_INVOKED_BIN",
+                   owner: :hive, required: true)
+      end
+
+      unit_real = realpath_or(unit_binary)
+      cli_real = realpath_or(cli_binary)
+      if unit_real == cli_real
+        # Optional version probe when the unit binary is runnable.
+        unit_ver = binary_version(unit_binary)
+        if unit_ver && unit_ver != Hive::VERSION
+          return row("daemon_binary", :drifted,
+                     "unit binary version #{unit_ver} != CLI #{Hive::VERSION}",
+                     "hive daemon install --force",
+                     owner: :hive, required: true)
+        end
+        return ok("daemon_binary", "unit binary matches CLI (#{cli_real})", required: true)
+      end
+
+      row("daemon_binary", :drifted,
+          "unit binary #{unit_binary} != CLI #{cli_binary}",
+          "hive daemon install --force",
+          owner: :hive, required: true)
+    rescue StandardError => e
+      row("daemon_binary", :error, e.message, "hive daemon install --force",
+          owner: :hive, required: true)
+    end
+
+    def check_daemon_running
+      require "hive/pid_file"
+      probe = Class.new { include Hive::PidFile }.new
+      pid_file = File.join(Hive::Paths.state_home, ".daemon.pid")
+      unless File.exist?(pid_file)
+        return missing("daemon_running", "daemon not running (no pidfile)",
+                       "hive daemon start  # or: hive setup",
+                       owner: :hive, required: false)
+      end
+
+      # Reuse Daemon's ownership checks via a minimal probe.
+      payload = begin
+        YAML.safe_load(File.read(pid_file), permitted_classes: [ Symbol ])
+      rescue StandardError
+        nil
+      end
+      pid = payload.is_a?(Hash) ? payload["pid"].to_i : 0
+      if pid > 0 && process_alive?(pid)
+        ok("daemon_running", "running (pid #{pid})", required: false)
+      else
+        missing("daemon_running", "daemon pidfile stale or process dead",
+                "hive daemon start",
+                owner: :hive, required: false)
+      end
+    end
+
+    def daemon_installer
+      require "hive/commands/daemon/service_installer"
+      @daemon_installer ||= Hive::Commands::Daemon::ServiceInstaller.new
+    end
+
+    def agent_bin(name)
+      env_key = "HIVE_#{name.upcase}_BIN"
+      override = ENV[env_key].to_s
+      return override unless override.empty?
+
+      name
+    end
+
+    def find_qmd
+      env_qmd = ENV["HIVE_QMD_BIN"].to_s
+      return env_qmd if !env_qmd.empty? && File.executable?(env_qmd)
+
+      path_qmd = which("qmd")
+      return path_qmd if path_qmd
+
+      candidates = [
+        File.join(@data_home, "qmd", "bin", "qmd"),
+        File.join(Hive::Paths.data_home, "qmd", "bin", "qmd")
+      ]
+      candidates.find { |c| File.file?(c) && File.executable?(c) }
+    end
+
+    def which(name)
+      return nil if name.nil? || name.empty?
+      return name if name.include?(File::SEPARATOR) && File.file?(name) && File.executable?(name)
+
+      ENV["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+        path = File.join(dir, name)
+        return path if File.file?(path) && File.executable?(path)
+      end
+      nil
+    end
+
+    def capture(*argv)
+      out, err, status = Timeout.timeout(15) { Open3.capture3(*argv) }
+      [ (out.to_s + err.to_s), status.success? ]
+    rescue Timeout::Error, SystemCallError => e
+      [ e.message, false ]
+    end
+
+    def binary_version(path)
+      out, ok = capture(path, "version")
+      return nil unless ok
+
+      out.to_s[/\d+\.\d+\.\d+/]
+    end
+
+    def realpath_or(path)
+      File.exist?(path) ? File.realpath(path) : File.expand_path(path)
+    rescue SystemCallError
+      File.expand_path(path)
+    end
+
+    def process_alive?(pid)
+      Process.kill(0, pid)
+      true
+    rescue Errno::ESRCH, Errno::EPERM
+      false
+    end
+
+    def ok(name, detail, required:)
+      row(name, :ok, detail, nil, owner: :hive, required: required)
+    end
+
+    def ok_row(name, detail, required:)
+      row(name, :ok, detail, nil, owner: owner_for(name), required: required)
+    end
+
+    def missing(name, detail, fix, owner:, required:)
+      row(name, :missing, detail, fix, owner: owner, required: required)
+    end
+
+    def row(name, status, detail, fix_command, owner:, required:)
+      Row.new(
+        name: name,
+        status: status,
+        detail: detail,
+        fix_command: fix_command,
+        owner: owner,
+        required: required
+      )
+    end
+
+    def owner_for(name)
+      case name
+      when "ruby", "git", "tmux", "node", "npm", "gh", "claude", "codex" then :external
+      else :hive
+      end
+    end
+  end
+end
